#include<stdio.h>
#include<string.h>

typedef struct pacijent
{
	int potrebno;
	char grupa[2];
	int obroj = 0;
	int abroj = 0;
	int bbroj = 0;
	int abbroj = 0;
}Pacijent;

int main()
{
	int n, o, a, b, abx;
	
	scanf("%d", &n);
	scanf("%d%d%d%d", &o, &a, &b, &ab);
	Pacijent pacijent[n];
	for (int i = 0; i < n; i++)
		scanf("%c%c%d", &pacijent[i].grupa[0], &pacijent[i].grupa[1], &pacijent[i].potrebno);
	
	for (int i = 0; i < n; i++)
		if (strcmp(pacijent[i].grupa, "O ") == 0)
			o -= pacijent[i].potrebno;
	for (int i = 0; i < n; i++)
		if (strcmp(pacijent[i].grupa, "A ") == 0)
		{
			a -= pacijent[i].potrebno;
			if (a < 0)
				{
					o += a;
					a = 0;
				}
		}
	for (int i = 0; i < n; i++)
		if (strcmp(pacijent[i].grupa, "B ") == 0)
		{
			b -= pacijent[i].potrebno;
			if (b < 0)
				{
					o += b;
					b = 0;
				}
		}
	for (int i = 0; i < n; i++)
		if (strcmp(pacijent[i].grupa, "AB") == 0)
		{
			ab -= pacijent[i].potrebno;
			if (ab < 0)
				{
					b += ab;
					ab = 0;
				}
			if (b < 0)
				{
					a += b;
					b = 0;
				}
			if (a < 0)
				{
					o += a;
					a = 0;
				}
		}
		
	return 0;
}